SystemOrganization addCategory: #'reunidosTADP-Tests'!

TestCase subclass: #TestCosteablesPorHora
	instanceVariableNames: 'transporte catering theHost personaAsignadaAlProyecto personaNoAsignada unaReunion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCosteablesPorHora methodsFor: 'as yet unclassified' stamp: 'jvillarejo 4/20/2012 22:13'!
setUp

	
	| unRequerimiento unaEmpresa |
	theHost:= Persona nuevaAsignadaA: 'ace' conRol:'PM'  enUnEdificio: 'Catalinas' sector: 'management'.
	personaAsignadaAlProyecto := Persona nuevaAsignadaA: 'ace' conRol:'programador'  enUnEdificio: 'Catalinas' sector: 'IT'. 
	personaNoAsignada := Persona nuevaAsignadaA: 'notes' conRol: 'PM'  enUnEdificio: 'Huergo1'sector: 'management'. 
	
	unaEmpresa := Empresa new.
	unRequerimiento:= Requerimiento new.

	unaReunion := Reunion nuevaConRequerimiento: unRequerimiento convocadaPor:  theHost duracion:   3 empresa: unaEmpresa.	
	transporte := Transporte new.
	transporte costoPorHora: 5.
	catering := Catering new.
	catering costoPorHora: 8.
	personaAsignadaAlProyecto costoPorHora: 20.
	personaNoAsignada costoPorHora: 20.! !

!TestCosteablesPorHora methodsFor: 'as yet unclassified' stamp: 'jvillarejo 4/20/2012 22:14'!
testCostoDeCatering
	self assert: catering costoPara: unaReunion == 24! !

!TestCosteablesPorHora methodsFor: 'as yet unclassified' stamp: 'jvillarejo 4/20/2012 22:14'!
testCostoDePersonaDelProyecto
	self assert: personaAsignadaAlProyecto  costoPara: ReunionFactory dameUnaReunionInicializada == 0! !

!TestCosteablesPorHora methodsFor: 'as yet unclassified' stamp: 'jvillarejo 4/20/2012 22:14'!
testCostoDePersonaFueraDeProyecto
	self assert: personaNoAsignada  costoPara: unaReunion == 60! !

!TestCosteablesPorHora methodsFor: 'as yet unclassified' stamp: 'jvillarejo 4/20/2012 22:14'!
testCostoDeTransporte
	self assert transporte costoPara: unaReunion == 15
	! !

TestCase subclass: #TestCriterioMultiple
	instanceVariableNames: 'persona criterio persona2 persona3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCriterioMultiple methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:17'!
setUp
|association1 association2|
persona:= Persona nuevaAsignadaA: 'ace' conRol: 'programador'  enUnEdificio:  'Alem' sector: 'IT'.
persona2:= Persona nuevaAsignadaA: 'ace' conRol: 'diseadorDeSistemas'  enUnEdificio: 'Catalinas' sector: 'IT'.
persona3:= Persona nuevaAsignadaA: 'notes' conRol:'PM'  enUnEdificio: 'Martinez' sector: 'Management'.
criterio:= CriterioMultiple new criterios: Dictionary new; personasConvocables: Set new.
"association1:= Association key: 'rol' value: 'Developer'.
association2:= Association key: 'proyecto' value:'ace'. 
criterio criterios add: association1.
criterio criterios add: association2."
criterio criterios at: 'rol' put: 'programador'; at: 'proyecto' put: 'ace'.
criterio personasConvocables add: persona; add: persona2; add: persona3.! !

!TestCriterioMultiple methodsFor: 'tests' stamp: 'ClaraAllende 4/20/2012 09:55'!
testPersonaCumpleTodosLosCriterios

criterio filtra: criterio personasConvocables .
"self assert: persona proyecto equals: (criterio criterios at: 'proyecto').
self assert: persona rol equals: (criterio criterios at: 'rol')."

self assert: (criterio personasConvocables includes: persona)! !

TestCase subclass: #TestCriterioSimple
	instanceVariableNames: 'persona criterio persona2 persona3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestCriterioSimple methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:10'!
setUp

persona:= Persona nuevaAsignadaA: 'ace' conRol: 'programador' enUnEdificio:'huergo2' sector: 'IT'.
persona2:= Persona nuevaAsignadaA: 'ace' conRol:'PM'  enUnEdificio:'Alem' sector: 'management'.
persona3:=  Persona nuevaAsignadaA: 'notes' conRol:'programador'  enUnEdificio: 'Martinez' sector: 'IT'. 
criterio:= CriterioUnico new condicion: 'proyecto'; parametro: 'ace'; personasConvocables: Set new.
criterio personasConvocables add: persona; add: persona2 ; add:persona3.! !

!TestCriterioSimple methodsFor: 'tests' stamp: 'ClaraAllende 4/19/2012 13:25'!
testPersonaCumpleCriterio
 
criterio filtra: criterio personasConvocables.
self assert: (criterio personasConvocables includes: persona).
self assert: persona proyecto equals: criterio parametro.! !

TestCase subclass: #TestHorarioDisponible
	instanceVariableNames: 'persona horarioOcupado rangoUno rangoDos coleccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestHorarioDisponible methodsFor: 'running' stamp: 'LucasGiudice 4/20/2012 15:02'!
setUp 
|inicioRango1 finRango1 inicioRango2 finRango2 rangoCuatro rangoTres |

inicioRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 19  minute: 15.
finRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 22  minute: 15.

rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

persona:= Persona new.
persona horariosOcupados add: rangoUno.

inicioRango2 := DateAndTime today. 
finRango2 := DateAndTime tomorrow.

rangoDos:= Rango new.
rangoDos start: inicioRango2; end: finRango2.
 
rangoTres:= Rango new.

rangoTres start: DateAndTime today; end: rangoUno start.

rangoCuatro:= rangoUno startingOn: rangoUno end.

coleccion := Set with: rangoTres with: rangoCuatro.! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:29'!
testPersonaHorariosDisponiblesRango
	"Verifica que todos los elementos de los horariosDisponibles esten contenidos en la coleccion que viene del #setUp y viceversa"

	| disponibles bol |
	disponibles := persona horariosDisponibles.
	self
		assert:
			(disponibles
				anySatisfy: [ :rangoDisponible | coleccion anySatisfy: [ :rangoPrueba | rangoPrueba equals: rangoDisponible ] ]).
	self
		assert:
			(coleccion
				anySatisfy: [ :rangoPrueba | disponibles anySatisfy: [ :rangoDisponible | rangoPrueba equals: rangoDisponible ] ])! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:38'!
testPersonaTenesDisponibleRango
	self assert: (persona tenesDisponible: rangoDos)! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:38'!
testPersonaTenesDuracionDisponible
	self assert: (persona tenesDuracionDisponible: rangoUno size).
	self assert: (persona tenesDuracionDisponible: rangoDos size)! !

!TestHorarioDisponible methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:40'!
testPersonaTenesDuracionDisponibleFalse
	"Si tiene al menos un horarioOcupado, la unica duracion que no tiene disponible es aquella que abarca desde hoy hasta el dia final"

	self assert: persona horariosOcupados notEmpty.
	self deny: (persona tenesDuracionDisponible: Rango rangoUniversal size)! !

TestCase subclass: #TestHorarioDuracionDisponibleDeRango
	instanceVariableNames: 'persona rangoUno'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestHorarioDuracionDisponibleDeRango methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 22:30'!
setUp 
|inicioRango1 finRango1 |

inicioRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 19  minute: 15.
finRango1 := DateAndTime year: 2012 month: 05 day: 21 hour: 19  minute: 35.

rangoUno:= Rango new.
rangoUno start: inicioRango1; end: finRango1.

persona:= Persona new.
persona ocupateDurante: rangoUno.
! !

!TestHorarioDuracionDisponibleDeRango methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 23:16'!
testDuracionDisponible


self assert: (persona tenesDuracionDisponible: rangoUno size ).! !

!TestHorarioDuracionDisponibleDeRango methodsFor: 'as yet unclassified' stamp: 'LucasGiudice 4/20/2012 23:23'!
testDuracionDisponibleDeRango



self assert: (persona duracionDisponibleDe: rangoUno size ) size >= rangoUno size.! !

TestCase subclass: #TestRequerimiento
	instanceVariableNames: 'criterio1 unRequerimiento criterio2 persona1 persona2 persona3 set1 set2 set3 persona4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

TestRequerimiento class
	instanceVariableNames: 'set2 persona1 persona2 persona3'!

TestRequerimiento class
	instanceVariableNames: 'set2 persona1 persona2 persona3'!

!TestRequerimiento methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:03'!
setUp

criterio1:= CriterioUnico nuevoConCondicion: 'rol' yParametro: 'PM'.
criterio2:= CriterioMultiple nuevoConCondiciones: (#('rol' 'proyecto' 'nombre')) parametros: (#('programador' 'ace' 'Clari')).
persona1:= Persona nuevaAsignadaA: 'ace' conRol:'programador'  enUnEdificio: 'Catalinas' sector: 'IT'. 
persona1 nombre: 'Clari'.
persona2:= Persona nuevaAsignadaA: 'notes' conRol: 'PM'  enUnEdificio: 'Huergo1'sector: 'management'. 
persona3:= Persona nuevaAsignadaA: 'costSuite' conRol: 'diseadorGrafico' enUnEdificio: 'Alem' sector:'IT'.
persona4:= Persona nuevaAsignadaA: 'estimatedCost' conRol: 'diseadorDeSIstemas' enUnEdificio: 'Martinez' sector:'IT'. 
unRequerimiento:= Requerimiento new requerimientosDeTurno:  (Set with: criterio1 with: criterio2).
unRequerimiento personas: Set new.

set1:= Set with: persona1 with: persona2.
set2:= Set with: persona1 with: persona2 with: persona3.
set3:= Set with: persona3 with: persona4.! !

!TestRequerimiento methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:37'!
testPersonasCumplenRequerimiento
	"va a seguir fallando hast que se inicialize la reunion, ahora dice que en el metodo posiblesAsistentesConDisponibilidadHoraria nil esta recibiendo el mje duracion."

	unRequerimiento personas: set1.
	unRequerimiento seleccionarAsistentes.
	self
		assert: (unRequerimiento convocados includesAllOf: set1)
		description: 'Existen personas que satisfacen el requerimiento'! !

!TestRequerimiento methodsFor: 'tests' stamp: 'Paul 4/20/2012 19:37'!
testPersonasNoCumplenRequerimiento
	unRequerimiento personas: set3.
	unRequerimiento seleccionarAsistentes.
	self
		deny: (unRequerimiento convocados includesAllOf: set3)
		description: 'No hay ninguna persona que cumpla el requerimiento'! !

TestCase subclass: #TestReunion
	instanceVariableNames: 'ibm theHost criterio1 criterio2 persona1 persona2 persona3 persona4 unRequerimiento set1 set2 set3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'reunidosTADP-Tests'!

!TestReunion methodsFor: 'running' stamp: 'ClaraAllende 4/20/2012 15:36'!
setUp

ibm:= Empresa new.
theHost:= Persona nuevaAsignadaA: 'ace' conRol:'PM'  enUnEdificio: 'Catalinas' sector: 'management'.
criterio1:= CriterioUnico nuevoConCondicion: 'rol' yParametro: 'PM'.
criterio2:= CriterioMultiple nuevoConCondiciones: (#('rol' 'proyecto' 'nombre')) parametros: (#('programador' 'ace' 'Clari')).
persona1:= Persona nuevaAsignadaA: 'ace' conRol:'programador'  enUnEdificio: 'Catalinas' sector: 'IT'. 
persona1 nombre: 'Clari'.
persona2:= Persona nuevaAsignadaA: 'notes' conRol: 'PM'  enUnEdificio: 'Huergo1'sector: 'management'. 
persona3:= Persona nuevaAsignadaA: 'costSuite' conRol: 'diseadorGrafico' enUnEdificio: 'Alem' sector:'IT'.
persona4:= Persona nuevaAsignadaA: 'estimatedCost' conRol: 'diseadorDeSistemas' enUnEdificio: 'Martinez' sector:'IT'. 
unRequerimiento:= Requerimiento new requerimientosDeTurno:  (Set with: criterio1 with: criterio2).

set1:= Set with: persona1 with: persona2.
set2:= Set with: persona1 with: persona2 with: persona3.
set3:= Set with: persona3 with: persona4.! !

!TestReunion methodsFor: 'tests' stamp: 'ClaraAllende 4/20/2012 17:13'!
testSePuedeRealizarReunion

"TODO"

! !
